#include <stdarg.h>
#include <stdio.h>

char *stdio_gets(char *str) {
    return gets(str);
}

int stdio_puts(char *str) {
    return puts(str);
}

int stdio_getchar() {
	return getchar();
}

int stdio_putchar(int c) {
	return putchar(c);
}

int stdio_vsscanf(const char *str, const char *format, va_list ap) {
	return vsscanf(str, format, ap);
}

int stdio_sscanf(const char *str, const char *format, ...) {
	int status;
    	va_list ap;
	va_start(ap,format);
	status=stdio_vsscanf(str, format, ap);
	va_end(ap);	
	return status;
}

int stdio_vscanf(const char *format, va_list ap) {
	return vscanf(format, ap);
}

int stdio_scanf(const char *format, ...) {
	int status;
    	va_list ap;
	va_start(ap,format);
	status=stdio_vscanf(format, ap);
	va_end(ap);	
	return status;
}

int stdio_vsprintf(const char *str, const char *format, va_list ap) {
#ifdef __GNUC__
	return vsprintf((char *)str, format, ap);
#else
	return vsprintf((char *)str, format, ap);
#endif
}

int stdio_sprintf(const char *str, const char *format, ...) {
	int status;
    	va_list ap;
	va_start(ap,format);
	status=stdio_vsprintf(str, format, ap);
	va_end(ap);	
	return status;
}

int stdio_vprintf(const char *format, va_list ap) {
	return vprintf(format, ap);
}

int stdio_printf(const char *format, ...) {
	int status;
    	va_list ap;
	va_start(ap,format);
	status=stdio_vprintf(format, ap);
	va_end(ap);	
	return status;
}
